OpenShot Audio Library | OpenShotAudio: juce::GenericScopedTryLock< LockType > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::GenericScopedTryLock< LockType > Class Template Reference

`#include <juce_ScopedLock.h>`

## Public Member Functions
| GenericScopedTryLock (const LockType &lock, bool acquireLockOnInitialisation=true) noexcept
| ~GenericScopedTryLock () noexcept
bool | isLocked () const noexcept
bool | retryLock () const noexcept

## Detailed Description

template<class LockType>
class juce::GenericScopedTryLock< LockType >

Automatically locks and unlocks a mutex object.

Use one of these as a local variable to provide RAII-based locking of a mutex.

The templated class could be a CriticalSection, SpinLock, or anything else that provides enter() and exit() methods.

e.g.

CriticalSection myCriticalSection;
for (;;)
{
const GenericScopedTryLock<CriticalSection> myScopedTryLock (myCriticalSection);
// Unlike using a ScopedLock, this may fail to actually get the lock, so you
// should test this with the isLocked() method before doing your thread-unsafe
// action..
if (myScopedTryLock.isLocked())
{
...do some stuff...
}
else
{
..our attempt at locking failed because another thread had already locked it..
}
// myCriticalSection gets unlocked here (if it was locked)
}
juce::CriticalSection
Definition: juce_CriticalSection.h:43
juce::GenericScopedTryLock
Definition: juce_ScopedLock.h:198

See also
  CriticalSection::tryEnter, GenericScopedLock, GenericScopedUnlock

Definition at line 197 of file juce_ScopedLock.h.

## Constructor & Destructor Documentation

## ◆ GenericScopedTryLock()

template<class LockType >

juce::GenericScopedTryLock< LockType >::GenericScopedTryLock | ( | const LockType & | lock,
|  | bool | acquireLockOnInitialisation = `true`
| ) |  |
| inlineexplicitnoexcept

Creates a GenericScopedTryLock.

If acquireLockOnInitialisation is true then as soon as this ScopedTryLock is created, it will attempt to acquire the lock with tryEnter.

You can retry acquiring the lock by calling retryLock.

When GenericScopedTryLock is deleted, the lock will be released (if the lock was successfully acquired).

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

See also
  retryLock, isLocked

Definition at line 217 of file juce_ScopedLock.h.

## ◆ ~GenericScopedTryLock()

template<class LockType >

juce::GenericScopedTryLock< LockType >::~GenericScopedTryLock | ( |  | ) |
| inlinenoexcept

Destructor.

The mutex will be unlocked (if it had been successfully locked) when the destructor is called.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen!

Definition at line 228 of file juce_ScopedLock.h.

## Member Function Documentation

## ◆ isLocked()

template<class LockType >

bool juce::GenericScopedTryLock< LockType >::isLocked | ( |  | ) | const
| inlinenoexcept

Returns true if the mutex was successfully locked.

Definition at line 231 of file juce_ScopedLock.h.

## ◆ retryLock()

template<class LockType >

bool juce::GenericScopedTryLock< LockType >::retryLock | ( |  | ) | const
| inlinenoexcept

Retry gaining the lock by calling tryEnter on the underlying lock.

Definition at line 234 of file juce_ScopedLock.h.

The documentation for this class was generated from the following file:

- juce_ScopedLock.h